from dune.perftool.loopy.transformer import quadrature_iname
from dune.perftool.generation import symbol, temporary_variable
from dune.perftool.pdelab import quadrature_preamble


@symbol
def quadrature_rule():
    return "rule"


def define_quadrature_factor(fac):
    rule = quadrature_rule()
    code = "auto {} = {}->weight();".format(fac, rule)
    return quadrature_preamble(code, assignees=fac)


@symbol
def name_factor():
    temporary_variable("fac")
    define_quadrature_factor("fac")
    return "fac"
